import string
import random
from scipy import *

class Bind:
  def __init__(self, func, args):
    self.func = func
    self.args = args

  def __call__(self, *remaining_args):
    return self.func(*(self.args + list(remaining_args)))

def load_csv(fname):  
  f = open(fname)
  lines = f.readlines()
  f.close()
  data = []
  for line in lines:
    data.append([float(x) for x in string.split(line)])
  return array(data)

def dump_csv(data, fname):
  f = open(fname, 'w')
  for row in data:
    for v in row:
      f.write(str(v) + " ")
    f.write('0\n')
  f.close()

def csv_str(v):
  s = ""
  for x in v:
    s += str(x) + " "
  return s

def dot(a, b):
  res = 0
  for i in range(0, len(a)):
    res += a[i] * b[i]
  return res

# transforms a row matrix into a vector
def to_array(m):
  return array(take(m, [0], 0))[0]

def distance(v1, v2):
  diff = v1 - v2
  diff = dot(diff, diff)
  return diff

# domain : matrix, each row is the range of one var
def dump_func(func, domain, step, file):
  f = open(file, 'w')
  cur_point = to_array(domain[:,0].T)
  def walk(var):
    x = domain[var,0]
    while (x < domain[var,1]):
      cur_point[var] = x
      if (var < len(domain) - 1):
        walk(var + 1)
      else:
        f.write(csv_str(cur_point) + str(func(cur_point)) + "\n")
      x += step[var]
  walk(0)
  f.close()

def gaussian(mean, variation, p):
  n = len(mean)
  a = -0.5 * mat(p - mean) * variation.I * mat(p - mean).T
  num = math.exp(float(a))
  den = (2 * pi) ** n * sqrt(linalg.det(variation))
  return (num / den)

def distinct_randint_vals(k, start, end):
  values = {}
  nb_vals = 0
  while (nb_vals < k):
    r = random.randint(start, end)
    while (values.has_key(r)):
      r = random.randint(start, end)
    values[r] = 1
    nb_vals += 1
  return values.keys()
